#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <time.h>

struct Game {
    char choice[100];
    long long int balance;
    long long int bet;
    int correct;
    int guess;
    int answer;
};

void init() {
  setvbuf(stdin, 0, 2, 0);
  setvbuf(stdout, 0, 2, 0);
  setvbuf(stderr, 0, 2, 0);
  alarm(180);
}

void print_flag() {
    FILE* f = fopen("/flag.txt", "r");
    if (f == NULL) {
        fputs("error reading flag!", stderr);
        exit(1);
    }
    char flag[256];
    fgets(flag, sizeof(flag), f);
    fclose(f);
    puts("What the... how did you get that money (even when I tried to stop you)!? I guess you beat me!");
    printf("The flag is %s\n", flag);
    puts("Thant you for playing !");
}

void menu1() {
    puts("Rules of game:");
    puts("(1) You will be given 500$");
    puts("(2) Place a Bet");
    puts("(3) Guess the number what computer thinks of !");
    puts("(4) computer's number changes every new time !.");
    puts("(5) You have to guess a nubmer between 1-10");
    puts("(6) You have only 10 tries !.");
    puts("(7) If you guess a number > 10, it still counts as a Try !");
    puts("(8) Put your mind, Win the game !..");
    puts("(9) If you guess within the number of tries, you win money !");
    puts("(10) Good Luck !..");
    puts("");
    puts("???:");
    puts("\tI bet you cannot get past $1000000!");
    puts("");
    printf("Are you ready? Y/N : ");
}

int generate_random_number() {
    srand( time(NULL) );
    return (rand() % 10) +1;
}

void game1() {
    struct Game game = {.balance = 500, .bet = 500, .correct = 0, .answer = generate_random_number()};

    do {
        menu1();
        scanf("%s", game.choice);
        puts("");
    } while (game.choice[0] != 'Y' && game.choice[0] != 'y');

    printf("Money you have : %lld$\n", game.balance);
    while (1) {
        game.correct = 0;
        do {
            printf("Place a Bet : ");
            scanf("%lld", &game.bet);
            if (game.balance - game.bet < 0) {
                puts("You don't have enough money to bet!\n");
            }
        } while (game.balance - game.bet < 0);

        for (int i=10; i>0; i--) {
            printf("#%d: Make a Guess : ", 11-i);
            scanf("%d", &game.guess);
            if (game.guess == game.answer) {
                game.correct = 1;
                break;
            } else {
                puts("wrong guess!\n");
            }
        }

        if (game.correct) {
            puts("Oh, you guess it!\n");
            game.balance += game.bet;
        } else {
            puts("No guess left, you lose. So unlucky!.\n");
            game.balance -= game.bet;
        }

        printf("You now have : %lld$\n", game.balance);
        
        if (game.balance > 1000000) {
            puts("What the... how did you get that money (even when I tried to stop you)!?");
            printf("I guess you beat me");
            for (int j = 0; j < 3; j++){
                sleep(1);
                printf(".");
            }
            printf(" wait");
            for (int j = 0; j < 3; j++){
                sleep(1);
                printf(".");
            }
            printf("\nI remember this happened before");
            for (int j = 0; j < 3; j++){
                sleep(1);
                printf(".");
            }
            printf("\nare you cheating???");
            sleep(1);
            puts("\nNevermind, let's restart the game with new rule.\n");
            sleep(1);
            break;
        }

        printf("Continue? Y/N : ");
        scanf("%s", game.choice);
        puts("");
        if (game.choice[0] != 'Y' && game.choice[0] != 'y') {
            puts("Bye");
            exit(0);
        }
    }
}

void menu2() {
    puts("Rules of game:");
    puts("(1) Almost same as the privious game.");
    puts("(2) No more negative number.");
    puts("(3) You can only guess once for each bet.");
    puts("");
    puts("cire meat pop:");
    puts("\tI bet you cannot get past $1000000!");
    puts("");
    printf("Are you ready? Y/N : ");
}

void game2() {
    struct Game game = {.balance = 500, .bet = 500, .answer = generate_random_number()};

    do {
        menu2();
        scanf("%s", game.choice);
        puts("");
    } while (game.choice[0] != 'Y' && game.choice[0] != 'y');

    printf("Money you have : %lld$\n", game.balance);
    while (1) {
        do {
            printf("Place a Bet : ");
            scanf("%lld", &game.bet);
            if (game.bet < 0) {
                puts("You are cheating! Get out of here!!!!!!!!!");
                exit(0);
            }
            if (game.balance - game.bet < 0) {
                puts("You don't have enough money to bet!\n");
            }
        } while (game.balance - game.bet < 0);

        printf("Make a Guess : ");
        scanf("%d", &game.guess);

        if (game.guess == game.answer) {
            puts("Oh, you guess it!\n");
            game.balance += game.bet;
        } else {
            puts("wrong guess!\n");
            game.balance -= game.bet;
        }

        printf("You now have : %lld$\n", game.balance);
        
        if (game.balance > 1000000) {
            break;
        }

        printf("Continue? Y/N : ");
        scanf("%s", game.choice);
        puts("");
        if (game.choice[0] != 'Y' && game.choice[0] != 'y') {
            puts("Bye");
            exit(0);
        }
    }
}

int main() {
    init();
    puts("Welcome to the Game of Luck2!");
    puts("");
    puts("Win me to get the flag!");
    puts("");
    game1();
    game2();
    print_flag();
}